package io.zipcoder.crudapp;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
public class PersonController {

    private PersonRepository personRepository;

    @Autowired
    public PersonController(PersonRepository repository) {
        this.personRepository = repository;
    }

    @PostMapping("/people")
    public ResponseEntity<Person> createPerson(@RequestBody Person p) {
        personRepository.save(p);
        return new ResponseEntity<>(HttpStatus.CREATED);
    }

    @GetMapping("/people/{id}")
    public ResponseEntity<Person> getPerson(@PathVariable Long id) {
        personRepository.findOne(id);
        return new ResponseEntity<>(HttpStatus.OK);
    }

    @GetMapping("/people")
    public ResponseEntity<Iterable<Person>> getPersonList(){
        personRepository.findAll();
        return new ResponseEntity<>(HttpStatus.OK);
    }

    @PutMapping("/people/{id}")
    public ResponseEntity<?> updatePerson(@RequestBody Person person, @PathVariable Long id) {
       personRepository.save(person);
        return new ResponseEntity<>(HttpStatus.OK);
    }

    @DeleteMapping ("/people/{id}")
    public ResponseEntity<?> deletePerson(@PathVariable Long id) {
        personRepository.delete(id);
        return new ResponseEntity<>(HttpStatus.ACCEPTED);
    }
}
